#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2500five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 2500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five25004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five25004xi = {
                1: '-1000x582y2215z',
                2: '-1008x1552y1680z',
                3: '-1042x1398y1790z',
                4: '-1049x538y2204z',
                5: '-104x17y2497z',
                6: '-1096x492y2192z',
                7: '-1097x1510y1661z',
                8: '-1109x2106y761z',
                9: '-1126x1356y1772z',
                10: '-1141x442y2180z',
                11: '-117x757y2379z',
                12: '-1183x388y2167z',
                13: '-1185x1464y1643z',
                14: '-1207x1308y1755z',
                15: '-1222x2052y737z',
                16: '-1222x331y2155z',
                17: '-1259x271y2142z',
                18: '-1271x1412y1624z',
                19: '-1286x1255y1737z',
                20: '-1293x209y2129z',
                21: '-130x14y2496z',
                22: '-1323x143y2116z',
                23: '-1332x1991y713z',
                24: '-1350x75y2102z',
                25: '-1355x1355y1605z',
                26: '-1363x1197y1719z',
                27: '-1373x4y2089z',
                28: '-1436x1293y1585z',
                29: '-1438x1135y1700z',
                30: '-1438x1924y689z',
                31: '-1509x1068y1682z',
                32: '-1514x1226y1566z',
                33: '-1541x1852y665z',
                34: '-155x8y2495z',
                35: '-1577x996y1663z',
                36: '-1588x1154y1546z',
                37: '-161x773y2371z',
                38: '-1641x1773y641z',
                39: '-1641x920y1645z',
                40: '-1659x1077y1527z',
                41: '-1702x841y1626z',
                42: '-1727x997y1507z',
                43: '-1736x1689y616z',
                44: '-1758x757y1607z',
                45: '-176x1683y1840z',
                46: '-1790x912y1487z',
                47: '-1811x669y1587z',
                48: '-181x0y2493z',
                49: '-1826x1600y592z',
                50: '-1849x823y1467z',
                51: '-1858x578y1568z',
                52: '-1901x484y1549z',
                53: '-1903x730y1446z',
                54: '-1912x1506y568z',
                55: '-1939x387y1529z',
                56: '-1952x634y1426z',
                57: '-1972x287y1509z',
                58: '-1993x1407y543z',
                59: '-1996x535y1405z',
                60: '-1999x185y1489z',
                61: '-2035x432y1385z',
                62: '-2068x1303y519z',
                63: '-2069x327y1364z',
                64: '-208x786y2363z',
                65: '-2096x220y1343z',
                66: '-2101x84y1528z',
                67: '-2118x111y1322z',
                68: '-2134x0y1300z',
                69: '-2138x1196y494z',
                70: '-2202x1084y470z',
                71: '-2260x970y445z',
                72: '-2312x851y421z',
                73: '-2357x730y396z',
                74: '-2396x607y371z',
                75: '-2428x481y347z',
                76: '-2453x354y322z',
                77: '-2471x225y297z',
                78: '-2483x96y272z',
                79: '-256x797y2355z',
                80: '-265x1554y1939z',
                81: '-267x1689y1823z',
                82: '-274x2306y925z',
                83: '-29x9y2499z',
                84: '-305x804y2347z',
                85: '-351x1557y1924z',
                86: '-357x808y2338z',
                87: '-359x1691y1805z',
                88: '-395x2297y902z',
                89: '-409x809y2329z',
                90: '-437x1555y1908z',
                91: '-452x1687y1788z',
                92: '-462x807y2320z',
                93: '-516x801y2310z',
                94: '-517x2282y879z',
                95: '-524x1548y1891z',
                96: '-545x1678y1770z',
                97: '-54x14y2499z',
                98: '-571x792y2301z',
                99: '-5x2y2499z',
                100: '-611x1535y1875z',
                101: '-626x779y2291z',
                102: '-638x1663y1753z',
                103: '-638x2260y855z',
                104: '-681x762y2281z',
                105: '-698x1518y1858z',
                106: '-731x1644y1735z',
                107: '-736x741y2270z',
                108: '-758x2232y832z',
                109: '-75x738y2387z',
                110: '-785x1496y1841z',
                111: '-791x717y2260z',
                112: '-79x17y2498z',
                113: '-824x1618y1717z',
                114: '-845x689y2249z',
                115: '-872x1469y1824z',
                116: '-877x2196y808z',
                117: '-898x657y2238z',
                118: '-916x1588y1698z',
                119: '-950x621y2227z',
                120: '-958x1436y1807z',
                121: '-994x2155y784z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire2500five4xi" usage = "target function for charge25004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire2500five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2500FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2500FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2500FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2500FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2500FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five25004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2500FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2500FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2500FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five25004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five25004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2500FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2500FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2500FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2500five4xi.py                             
# -------------------------------------------------------------------------------------------------                